#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "wave.h"

int main(void)
{
  MONO_PCM pcm0; /* m̉f[^ */
  STEREO_PCM pcm1; /* XeỈf[^ */
  int n;
  double a, depth, rate;
  
  mono_wave_read(&pcm0, "sample08.wav"); /* WAVEt@C烂m̉f[^͂ */
  
  pcm1.fs = pcm0.fs; /* W{g */
  pcm1.bits = pcm0.bits; /* ʎqx */
  pcm1.length = pcm0.length; /* f[^̒ */
  pcm1.sL = calloc(pcm1.length, sizeof(double)); /* ̊m */
  pcm1.sR = calloc(pcm1.length, sizeof(double)); /* ̊m */
  
  depth = 1.0;
  rate = 0.2; /* 0.2Hz */
  
  /* I[gp */
  for (n = 0; n < pcm1.length; n++)
  {
    a = 1.0 + depth * sin(2.0 * M_PI * rate * n / pcm1.fs);
    pcm1.sL[n] = a * pcm0.s[n];
    
    a = 1.0 + depth * sin(2.0 * M_PI * rate * n / pcm1.fs + M_PI);
    pcm1.sR[n] = a * pcm0.s[n];
  }
  
  stereo_wave_write(&pcm1, "ex9_3.wav"); /* WAVEt@CɃXeỈf[^o͂ */
  
  free(pcm0.s); /* ̉ */
  free(pcm1.sL); /* ̉ */
  free(pcm1.sR); /* ̉ */
  
  return 0;
}
